<?php
if ( !defined( 'ABSPATH' ) ) exit;

//EXPORT CALL LOGS
//call logs can be export/dowwnloaded
add_action('admin_init', 'bsp_robo_export_logs');
function bsp_robo_export_logs() {

    if (!isset($_POST['bsp_robo_export_btn'])) {
        return;
    }
	$parameters = [];
	$form_ivr_date = "";
	$form_ivr_order = "";
	$form_ivr_phone = "";
	$form_ivr_id = "";
	$form_ivr_status = "";
	
	if (isset($_GET['bsp_aoc_search_btn'])) {

	    if (isset($_GET['form_ivr_date']) && !empty($_GET['form_ivr_date'])) {
	        $form_date = $_GET['form_ivr_date'];
	        $created_at_min = substr($_GET['form_ivr_date'], 0, 10) . ' 00:00:00';
	        $created_at_max = substr($_GET['form_ivr_date'], -10) . ' 23:59:59';
	        $parameters[] = [
	            'key' => 'ivr_datetime',
	            'value' => "'{$created_at_min}' AND '{$created_at_max}'",
	            'operator' => 'BETWEEN',
	        ];
	    }

		if (isset($_GET['form_ivr_order']) && !empty($_GET['form_ivr_order'])) {
			$parameters[] 	= [
				'key' 		=> 'order_number',
				'value' 	=> $_GET['form_ivr_order'],
				'operator' 	=> 'LIKE',
			];
		}

		if (isset($_GET['form_ivr_phone']) && !empty($_GET['form_ivr_phone'])) {
			$parameters[] 	= [
				'key' 		=> 'order_phone',
				'value' 	=> $_GET['form_ivr_phone'],
				'operator' 	=> 'LIKE',
			];
		}

		if (isset($_GET['form_ivr_id']) && !empty($_GET['form_ivr_id'])) {
			$parameters[] 	= [
				'key' 		=> 'ivr_id',
				'value' 	=> $_GET['form_ivr_id'],
				'operator' 	=> 'LIKE',
			];
		}

		if (isset($_GET['form_ivr_status']) && !empty($_GET['form_ivr_status'])) {
			$parameters[] = [
				'key' 	  => 'ivr_status',
				'value'	  => $_GET['form_ivr_status'],
				'operator' => 'LIKE',
			];
		}						
	}
	
	$bookings = new IVRCallLog([
	    'shop_url' => get_home_url(),
	]);
	$bookings->paginate_by = 100000;
	$parcels = [];
	$parcels = $bookings->get($parameters);
	$rows = [];
    $rows[] = [
  		'Datetime',
        'Order',
        'Phone', 
        'Total',
        'Gateway',
        'ID',
        'IVR API',
        'IVR Tries',
        'IVR Call',
        'IVR Status',   
    ];

    foreach ($parcels as $parcel) {		
    	$ivr_logs = json_decode($parcel->ivr_logs, true);
        $rows[] = [
            $parcel -> ivr_datetime,
            $parcel -> order_number,
            $parcel -> order_phone,
           	(int)$parcel -> order_total,
           	$parcel -> order_gateway,
           	$parcel -> ivr_id,
           	$parcel -> ivr_api,
           	$parcel -> ivr_retry,
           	$parcel -> ivr_call,
           	$parcel -> ivr_status,
        ];
    }
    header('Content-Type: text/csv');
    header('Content-Disposition: attachment; filename="bsp_robo_call-logs.csv";');
    header('Pragma: no-cache');
    header("Expires: 0");        

    $f = fopen('php://output', 'w'); 
    foreach ($rows as $line) { 
        fputcsv($f, $line); 
    }
   die();
}

function bsp_robo_logs_page() {

	// sync calls
	if (isset($_POST['bsp_robo_sync_btn'])) {
		bsp_robo_cron_function();
	}

	$parameters = [];
	$form_ivr_date = "";
	$form_ivr_order = "";
	$form_ivr_phone = "";
	$form_ivr_id = "";
	$form_ivr_status = "";

	if (isset($_GET['bsp_aoc_search_btn'])) {
	    if (isset($_GET['form_ivr_date']) && !empty($_GET['form_ivr_date'])) {
	        $form_date = $_GET['form_ivr_date'];
	        $created_at_min = substr($_GET['form_ivr_date'], 0, 10) . ' 00:00:00';
	        $created_at_max = substr($_GET['form_ivr_date'], -10) . ' 23:59:59';
	        $parameters[] 	= [
	            'key' 		=> 'ivr_datetime',
	            'value' 	=> "'{$created_at_min}' AND '{$created_at_max}'",
	            'operator' 	=> 'BETWEEN',
	        ];
	    }
		if (isset($_GET['form_ivr_order']) && !empty($_GET['form_ivr_order'])) {
			$parameters[] = [
				'key' 	  => 'order_number',
				'value'   => $_GET['form_ivr_order'],
				'operator' => 'LIKE',
			];
		}
		if (isset($_GET['form_ivr_phone']) && !empty($_GET['form_ivr_phone'])) {
			$parameters[]  = [
				'key' 	   => 'order_phone',
				'value'	   => $_GET['form_ivr_phone'],
				'operator' => 'LIKE',
			];
		}
		if (isset($_GET['form_ivr_id']) && !empty($_GET['form_ivr_id'])) {
			$parameters[] 	= [
				'key' 		=> 'ivr_id',
				'value' 	=> $_GET['form_ivr_id'],
				'operator' 	=> 'LIKE',
			];
		}
		if (isset($_GET['form_ivr_status']) && !empty($_GET['form_ivr_status'])) {
			$parameters[] 	= [
				'key' 		=> 'ivr_status',
				'value'		=> $_GET['form_ivr_status'],
				'operator' 	=> 'LIKE',
			];
		}
	}

	$bookings = new IVRCallLog([
	    'shop_url' => get_home_url(),
	]);
	$bookings -> paginate_by = 50;
	$page 		  = $_GET['hxs_page'] ?? 1;
	$last_seen 	  = $_GET['hxs_last_seen'] ?? null;
	$dir 		  = $_GET['hxs_dir'] ?? null;	
	$parcels 	  = $bookings->get($parameters, [], $page, $last_seen, $dir);
	$current_page = admin_url("admin.php");

?>

<head>
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">
	<link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-OERcA2EqjJCMA+/3y+gxIOqMEjwtxJY7qPCqsdltbNJuaOe923+mo//f6V8Qbsw3" crossorigin="anonymous"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>	
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">
	<link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-OERcA2EqjJCMA+/3y+gxIOqMEjwtxJY7qPCqsdltbNJuaOe923+mo//f6V8Qbsw3" crossorigin="anonymous"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/momentjs/latest/moment.min.js"></script>
	<script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
	<style>
		.bsp-aoc-log-table {
			font-size: 12px;
			white-space: nowrap
		}
		table { table-layout: fixed; }
 		table th, table td { white-space: normal !important; }
 		.dataTables_wrapper .dataTables_filter input {
 			margin-bottom: 10px;
 		}
		.dataTables_filter {
		   float: left !important;
		}
		.bsp-aoc-page-heading {
		    font-size: 20px;
		    font-weight: bold;
		    color: #000000;
		    text-decoration: none;			
		}	
		.table {
			 border: 1px solid #e0e0e0; 
		}
		.table thead th {
			border-top: 1px solid #e0e0e0 !important;
			border-bottom: 1px solid #e0e0e0 !important;
			border-left: 1px solid #e0e0e0;
			border-right: 1px solid #e0e0e0;
			padding: 3px 10px !important;
		}
		.table td {
			border-left: 1px solid #e0e0e0;
			border-right: 1px solid #e0e0e0;
			border-top: none !important;
			padding: 5px 10px !important;
			line-height: 20px !important;
		}
		.table>thead {
    	vertical-align: middle;
}
		
	</style>

</head>
<body>				
	<div class="container-fluid mt-4 mb-4">
		<div class="row">
			<div class="col-2">
				<a href="<?= $current_page ?>?page=bsp_robo_logs_page" class="bsp-aoc-page-heading">Call Logs</a>
			</div>
			<div class="col-7 alignleft actions bulkactions">
                <form class="input-group" method="get" action=""  id="hxs-sheet-form courier-name-all">
                    <?php
	                    foreach ($_GET as $key => $value) {
	                        if (in_array($key, ['hxs_page', 'hxs_last_seen', 'hxs_dir']))
	                            continue;
	                        $key   = htmlspecialchars($key);
	                        $value = htmlspecialchars($value);
	                        echo "<input type='hidden' name='$key' value='$value'/>";
	                    }
                    ?>
                    <input class="form-control" type="text" name="form_ivr_date" value="<?php $form_ivr_date ?>" autocomplete="off" placeholder="Date Range">
                    <input class="form-control" type="text" name="form_ivr_order" value="<?php $form_ivr_order ?>" autocomplete="off" placeholder="Order #">
                    <input class="form-control" type="text" name="form_ivr_phone" value="<?php $form_ivr_phone ?>" autocomplete="off" placeholder="Phone">                     
                    <input class="form-control" type="text" name="form_ivr_id" value="<?php $form_ivr_id ?>" autocomplete="off" placeholder="BSP ID">                   
	                <select name="form_ivr_status" class="form-select" style="max-width: 100px;">
	                		<option value="">Status</option>
	                        <option value="confirmed">Confirmed</option>
	                        <option value="cancelled">Cancelled</option>
	                        <option value="call back">Call Back</option>
	                </select>
                    <button class="button" name="bsp_aoc_search_btn" type="submit">Search</button>
                </form>
            </div>    
            <div class="col-2">
                <form method="POST" action="">
                	<button class="button" name="bsp_robo_sync_btn" type="submit">Sync</button>
                	<button class="button" name="bsp_robo_export_btn" type="submit">Export</button>
                </form>            	
            </div>
			<div class="col-2">
          		<?php 
					$get_params_without_hxs_pagination = '?';
					foreach ($_GET as $key => $value) {
						if (!in_array($key, ['hxs_page', 'hxs_last_seen', 'hxs_dir']))
							$get_params_without_hxs_pagination .= $key . "=" . $value . '&';
					}
				?>
                 <?php if ($next_page = $bookings->get_next()){ ?>
                    <a href="<?= $current_page ?><?= $get_params_without_hxs_pagination ?>hxs_page=<?= $next_page['page_num'] ?>&hxs_last_seen=<?= $next_page['last_seen']?>&hxs_dir=<?= IVRCallLog::$NEXT ?>" class="btn btn-secondary float-end">Next</a>
				
                <?php } if ($prev_page = $bookings->get_prev()){ ?>
                    <a href="<?= $current_page ?><?= $get_params_without_hxs_pagination ?>hxs_page=<?= $prev_page['page_num'] ?>&hxs_last_seen=<?= $prev_page['last_seen']?>&hxs_dir=<?= IVRCallLog::$PREV ?>" class="btn btn-secondary me-2 float-end">Back</a>
                <?php } ?> 
			</div>
		</div>
	</div>

	<div class="container">	
	<table class="wp-list-table widefat fixed striped table-view-list posts">
	<thead>
	    <tr>
		    <td id="cb" class="manage-column column-cb check-column"><label class="screen-reader-text" for="cb-select-all-1">Select All</label><input type="checkbox" id="checkAll"></th><label class="custom-control-label" for="customCheck1"></td>
		   	<th>Date</th>
		    <th>Name</th>
			<th>Amount</th>
		    <th>BSP ID</th>
			<th>Response</th>
			<th>Ext. Status</th>	    
			<th>Que</th>
			<th>Action</th>
	    </tr>
	</thead>
	<tbody id="the-list">
	<?php
				$count = 1;
				$bsp_aoc_log_pagination = 50;
				$bsp_aoc_log_pagination_minus = $bsp_aoc_log_pagination - 1;
				
                if (isset($_GET['hxs_page'])) {
                	$bsp_current_page = $_GET['hxs_page'];
	                if ($bsp_current_page == 2 ) {
	                	$count = $bsp_aoc_log_pagination + 1;
	                }
	                if ($bsp_current_page > 2 ) {
	                	$count = ($bsp_current_page * $bsp_aoc_log_pagination) - $bsp_aoc_log_pagination_minus;
	                }
	            }
	            else {
	            	$count = 1;
	            }

			    foreach($parcels as $log) {			
			    	$order_id 			= $log->order_id;
			    	$order 				= wc_get_order($order_id);
					$order_number		= $log->order_number;
					$order_phone		= $log->order_phone;
					$order_total 		= $log->order_total;
			    	$ivr_datetime 		= $log->ivr_datetime; 				
			    	$ivr_id 			= $log->ivr_id;
			    	//$ivr_api 			= $log->ivr_api;
					$ivr_callresponse    	=$log->ivr_callresponse;
					$ivr_api_return		= $log->ivr_api_return;
			    	//$ivr_retry			= $log->ivr_retry;			    	
			    	$ivr_call 			= $log->ivr_call;
			    	$ivr_status 		= $log->ivr_status;
			    	$ivr_call_que 		= $log->ivr_call_que;
					
			    	$ivr_logs 			= $log->ivr_logs;	
					{
					if($ivr_status == 'Confirmed') {
						$ivr_status_class = 'btn btn-sm btn-success';
					} else if($ivr_status == 'Cancelled') {
						$ivr_status_class = 'btn btn-sm btn-danger';
					} else if($ivr_status  == 'Call Back') {
						$ivr_status_class = 'btn btn-sm btn-warning';
					} else {
						$ivr_status 	  = 'Get Status';
						$ivr_status_class = 'button-secondary';
					} 
			    ?>
				<tr>
					<td class="text-center"><input type="checkbox" id="checkAll"></td>
              		<td class="text-left"><?= $ivr_datetime ?> </td>
					<td><a href="<?= get_home_url(); ?>/wp-admin/post.php?post=<?= $order_id ?>&action=edit" style="text-decoration: none;">Order # <?= $order_number ?></a><br><?= $order->get_billing_first_name() . ' ' . $order->get_billing_last_name() ?><br><?= $order_phone ?></td>
					<td class="text-left">Rs. <?= (int)$order_total ?></td>
					<td class="text-left"><?= $ivr_id ?></td>
					<td class="text-left"><?= $ivr_call ?></td>
				
					<td class="text-left"><?= $ivr_api_return ?></td> 
					<td class="text-left"><?= $ivr_call_que; ?></td>
					<td class="text-left">

						<?php if($ivr_id)   
						 ?>
						<span data-bs-toggle="modal" data-bs-target="#bsp_aoc_ivr_details">
	                    	<button class="<?= $ivr_status_class ?>" style="padding: 0px 10px;" type="submit" onclick="bsp_robo_log_responce_js('<?= $ivr_id ?>')"><?= $ivr_status ?></button> 
	                    </span>
			            <?php
			        	}
			        	?>
	                </td>
					
						
	                </td>
	            </tr>
		        <?php
		            $count++;
		        }		
		        ?>
    </tbody>
	<tfoot>
		<tr>
			<td id="cb" class="manage-column column-cb check-column"></td>
		    <th>Date</th>
		    <th>Name</th>
		    <th>Amount</th>
		    <th>BSP ID</th>
			<th>Response</th>
		    <th>Ext. Status</th>
			<th>Que</th>
			<th>Action</th>
		</tr>
	</tfoot>
	</table>
	    <div class="modal fade" id="bsp_aoc_ivr_details" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true" style="display: none;">
	        <div class="modal-dialog" style="max-width: 1000px">
	            <div class="modal-content">
	                <div class="modal-header">
	                    <h5 class="modal-title" id="exampleModalLabel">Call Logs:</h5>
	                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
	                </div>
	                <div class="modal-body">
	                	<div class="call_log_detail">
	                	</div>
	                </div>
	                <div class="modal-footer">
	                    <button type="button" class="btn btn-outline-success" data-bs-dismiss="modal">Close</button>
	                </div>
	            </div>
	        </div>
	    </div>
	</div> 
	<!-- END CONTAINER -->

	<div class="container-fluid">
		<div class="col-2 float-end">
	  		<?php 
				$get_params_without_hxs_pagination = '?';
				foreach ($_GET as $key => $value) {
					if (!in_array($key, ['hxs_page', 'hxs_last_seen', 'hxs_dir']))
						$get_params_without_hxs_pagination .= $key . "=" . $value . '&';
				}
			?>
	         <?php if ($next_page = $bookings->get_next()){ ?>
	            <a href="<?= $current_page ?><?= $get_params_without_hxs_pagination ?>hxs_page=<?= $next_page['page_num'] ?>&hxs_last_seen=<?= $next_page['last_seen']?>&hxs_dir=<?= IVRCallLog::$NEXT ?>" class="btn btn-secondary float-end">Next</a>

	        <?php } if ($prev_page = $bookings->get_prev()){ ?>
	            <a href="<?= $current_page ?><?= $get_params_without_hxs_pagination ?>hxs_page=<?= $prev_page['page_num'] ?>&hxs_last_seen=<?= $prev_page['last_seen']?>&hxs_dir=<?= IVRCallLog::$PREV ?>" class="btn btn-secondary me-2 float-end">Back</a>
	        <?php } ?> 
		</div>
	</div>	
    <script type="text/javascript">
        $(function() {
            $('input[name="form_ivr_date"]').daterangepicker({
                autoUpdateInput: <?php echo empty($form_ivr_date) ? 'false' : 'true' ?>,
                locale: {
                    cancelLabel: 'Clear',
                    format: "YYYY-MM-DD",
                }
            });

            $('input[name="form_ivr_date"]').on('apply.daterangepicker', function(ev, picker) {
                $(this).val(picker.startDate.format('YYYY-MM-DD') + ' - ' + picker.endDate.format('YYYY-MM-DD'));
            });

            $('input[name="form_ivr_date"]').on('cancel.daterangepicker', function(ev, picker) {
                $(this).val('');
            });

        });
    </script>
	<script type='text/javascript'>
		function bsp_robo_log_responce_js(ivr_id) {
			loading = "<center><img src=\"<?php echo plugin_dir_url( __DIR__ ) . 'assets/images/loading.gif'; ?>\"></center>"
		    jQuery(".call_log_detail").html(loading);
		    jQuery.ajax({
				type: 'POST',
		        url: '<?php echo admin_url('/admin-ajax.php'); ?>',
		        data: {
		            'action' : 'bsp_robo_get_call_ajax',
		            'ivr_id' : ivr_id,
		            'print'  : 'yes',
		        },                     
		        success: function (response) {
		            jQuery(".call_log_detail").html(response);
		        }                
		    });
		}
	
		//table-checkall-
		$("#checkAll").click(function () {
     $('input:checkbox').not(this).prop('checked', this.checked);
 });
	</script>
</body>
<?php 
}
?>